"""Initial migration

Revision ID: 3f8e6786bde9
Revises: 
Create Date: 2023-10-17 18:26:23.510471

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '3f8e6786bde9'
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('users',
    sa.Column('user_id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('user_name', sa.String(length=100), nullable=True),
    sa.Column('email_id', sa.String(length=100), nullable=True),
    sa.Column('role', sa.String(length=50), nullable=True),
    sa.Column('created_on', sa.DateTime(), nullable=True),
    sa.Column('modified_on', sa.DateTime(), nullable=True),
    sa.Column('is_active', sa.Boolean(), nullable=True),
    sa.PrimaryKeyConstraint('user_id'),
    sa.UniqueConstraint('user_name')
    )
    op.create_index(op.f('ix_users_created_on'), 'users', ['created_on'], unique=False)
    op.create_index(op.f('ix_users_email_id'), 'users', ['email_id'], unique=True)
    op.create_index(op.f('ix_users_modified_on'), 'users', ['modified_on'], unique=False)
    op.create_index(op.f('ix_users_user_id'), 'users', ['user_id'], unique=False)
    op.create_table('conversations',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('conversation_uuid', sa.String(length=50), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.Column('created_on', sa.DateTime(), nullable=True),
    sa.Column('modified_on', sa.DateTime(), nullable=True),
    sa.Column('ai_application_name', sa.String(length=100), nullable=False),
    sa.Column('title', sa.String(length=100), nullable=True),
    sa.Column('is_deleted', sa.Boolean(), nullable=False),
    sa.Column('client_app_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['user_id'], ['users.user_id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('id')
    )
    op.create_index(op.f('ix_conversations_ai_application_name'), 'conversations', ['ai_application_name'], unique=False)
    op.create_index(op.f('ix_conversations_client_app_id'), 'conversations', ['client_app_id'], unique=False)
    op.create_index(op.f('ix_conversations_conversation_uuid'), 'conversations', ['conversation_uuid'], unique=True)
    op.create_index(op.f('ix_conversations_created_on'), 'conversations', ['created_on'], unique=False)
    op.create_index(op.f('ix_conversations_modified_on'), 'conversations', ['modified_on'], unique=False)
    op.create_index(op.f('ix_conversations_user_id'), 'conversations', ['user_id'], unique=False)
    op.create_table('messages',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('message_uuid', sa.String(length=50), nullable=False),
    sa.Column('conversation_id', sa.Integer(), nullable=True),
    sa.Column('created_on', sa.DateTime(), nullable=True),
    sa.Column('content', sa.String(), nullable=True),
    sa.Column('original_content', sa.String(), nullable=True),
    sa.Column('type', sa.String(length=50), nullable=True),
    sa.Column('prompt_id', sa.String(length=50), nullable=True),
    sa.Column('auth_status', sa.String(length=50), nullable=True),
    sa.ForeignKeyConstraint(['conversation_id'], ['conversations.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('id')
    )
    op.create_index(op.f('ix_messages_conversation_id'), 'messages', ['conversation_id'], unique=False)
    op.create_index(op.f('ix_messages_created_on'), 'messages', ['created_on'], unique=False)
    op.create_index(op.f('ix_messages_message_uuid'), 'messages', ['message_uuid'], unique=True)
    op.create_index(op.f('ix_messages_prompt_id'), 'messages', ['prompt_id'], unique=False)
    op.create_index(op.f('ix_messages_type'), 'messages', ['type'], unique=False)
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_messages_type'), table_name='messages')
    op.drop_index(op.f('ix_messages_prompt_id'), table_name='messages')
    op.drop_index(op.f('ix_messages_message_uuid'), table_name='messages')
    op.drop_index(op.f('ix_messages_created_on'), table_name='messages')
    op.drop_index(op.f('ix_messages_conversation_id'), table_name='messages')
    op.drop_table('messages')
    op.drop_index(op.f('ix_conversations_user_id'), table_name='conversations')
    op.drop_index(op.f('ix_conversations_modified_on'), table_name='conversations')
    op.drop_index(op.f('ix_conversations_created_on'), table_name='conversations')
    op.drop_index(op.f('ix_conversations_conversation_uuid'), table_name='conversations')
    op.drop_index(op.f('ix_conversations_client_app_id'), table_name='conversations')
    op.drop_index(op.f('ix_conversations_ai_application_name'), table_name='conversations')
    op.drop_table('conversations')
    op.drop_index(op.f('ix_users_user_id'), table_name='users')
    op.drop_index(op.f('ix_users_modified_on'), table_name='users')
    op.drop_index(op.f('ix_users_email_id'), table_name='users')
    op.drop_index(op.f('ix_users_created_on'), table_name='users')
    op.drop_table('users')
    # ### end Alembic commands ###
